--TODO: further documentation

if DBM then
	function hook_SendAddonMessage(...)	
		-- Now check if the message should be resent through CHANNEL.
		-- We can't sent it ONLY through channel instead of guild, 
		-- or else players who don't have this patch won't see the message.
		-- Players who have the patch and are in the same subguild will receive the message twice,
		-- but we'll filter CHANNEL messages from own guild during syncHandler.
		
		-- We are scanning for only DBM's guild combat begin/end messages.
		-- These messages have prefix "D4",
		local prefix=select(1,...)
		-- start with "GCB" or "GCE"
		local message=select(2,...)
		local DBMcode=nil
		if(message)then
			DBMcode=string.sub(message,1,3)
		end
		-- and are type "GUILD".
		local type=select(3,...)
		local target=select(4,...)	
		
		--print("SendAddonMessage: ",prefix,message,DBMcode,type)
		
		----we set messagetype up this way for easier debugging...
		messagetype="GUILD"
		--messagetype="PARTY"
		
		-- Any other messages are ignored.	
		if((prefix=="D4")
		and (DBMcode=="GCB" or DBMcode=="GCE")
		and (type==messagetype)
		and gw
		and gw.config.channel.guild.number
		and gw.config.guild_id
		)then
			-- Send the message to CHANNEL
			-- but first, add the current guild name to the message.
			
			-- GCB message format:
			-- SendAddonMessage("D4", "GCB\t"..modId.."\t2\t"..difficultyIndex, "GUILD")
			-- GCE message format:
			-- (wipe)
			-- SendAddonMessage("D4", "GCE\t"..modId.."\t3\t1\t"..strFromTime(thisTime).."\t"..difficultyIndex.."\t"..wipeHP, "GUILD")
			-- (success)
			-- SendAddonMessage("D4", "GCE\t"..modId.."\t3\t0\t"..strFromTime(thisTime).."\t"..difficultyIndex, "GUILD")
			

			local arg={strsplit("\t", message)}
			local needWipeHP=false
			--print("arg7:",arg[7])
			if(DBMcode=="GCE" and not (arg[7]))then 
				message=message.."\t0%\t"..gw.config.guild_id
			else
				message=message.."\t"..gw.config.guild_id
			end
			

			--TODO LATER: listen only for greenwall channel, and no other channels, if possible
		
			
			SendAddonMessage(prefix,message,"CHANNEL",gw.config.channel.guild.number)
			-- (this will also call hook_SendAddonMessage again, 
			-- but since type isn't GUILD anymore, we won't get caught in an infinite loop.)
		end
	end
	hooksecurefunc("SendAddonMessage",hook_SendAddonMessage)



	-- We can hook into DBM.CHAT_MSG_ADDON
	-- syncHandlers and handleSync are local functions, so we must recreate them from scratch

	local fakeSyncHandlers = {}
	fakeSyncHandlers["GCB"] = function(sender, modId, ver, difficulty, guild)
		--print("GCE",sender,modId,ver,difficulty,"guild:",guild)
		if(not gw)then return end
		if(gw.config.guild_id==guild) then return end
		-- the remaining code is mostly copied directly from syncHandlers:
		if not DBM.Options.ShowGuildMessages or not difficulty then return end
		if not ver or not (ver == "2") then return end--Ignore old versions
		if DBM:AntiSpam(10, "GCB") then
			if IsInInstance() then return end--Simple filter, if you are inside an instance, just filter it, if not in instance, good to go.
			difficulty = tonumber(difficulty)
			if not DBM.Options.ShowGuildMessagesPlus and difficulty == 8 then return end
			local bossName = EJ_GetEncounterInfo(modId) or DBM_CORE_UNKNOWN
			local difficultyName = DBM_CORE_UNKNOWN
			if difficulty == 8 then
				difficultyName = PLAYER_DIFFICULTY6.."+"
			elseif difficulty == 16 then
				difficultyName = PLAYER_DIFFICULTY6
			elseif difficulty == 15 then
				difficultyName = PLAYER_DIFFICULTY2
			else 
				difficultyName = PLAYER_DIFFICULTY1
			end
			-- One change here: we add the guild name to the message
			DBM:AddMsg("|cff40fb40<"..guild..">|r".." "..DBM_CORE_GUILD_COMBAT_STARTED:format(difficultyName.."-"..bossName))
		end
	end
	fakeSyncHandlers["GCE"] = function(sender, modId, ver, wipe, time, difficulty, wipeHP, guild)	
		--print("GCE",sender,modId,ver,difficulty,"wipeHP:",wipeHP,"guild:",guild)
		if(not gw)then return end
		if(gw.config.guild_id==guild) then return end
		-- the remaining code is mostly copied directly from syncHandlers:
		if not DBM.Options.ShowGuildMessages or not difficulty then return end
		if not ver or not (ver == "3") then return end--Ignore old versions
		if DBM:AntiSpam(5, "GCE") then		
			if IsInInstance() then return end--Simple filter, if you are inside an instance, just filter it, if not in instance, good to go.
			difficulty = tonumber(difficulty)
			if not DBM.Options.ShowGuildMessagesPlus and difficulty == 8 then return end
			local bossName = EJ_GetEncounterInfo(modId) or DBM_CORE_UNKNOWN
			local difficultyName = DBM_CORE_UNKNOWN
			if difficulty == 8 then
				difficultyName = PLAYER_DIFFICULTY6.."+"
			elseif difficulty == 16 then
				difficultyName = PLAYER_DIFFICULTY6
			elseif difficulty == 15 then
				difficultyName = PLAYER_DIFFICULTY2
			else 
				difficultyName = PLAYER_DIFFICULTY1
			end
			-- again, add guild name to message here
			if wipe == "1" then
				DBM:AddMsg("|cff40fb40<"..guild..">|r".." "..DBM_CORE_GUILD_COMBAT_ENDED_AT:format(difficultyName.."-"..bossName, wipeHP, time))
			else
				DBM:AddMsg("|cff40fb40<"..guild..">|r".." "..DBM_CORE_GUILD_BOSS_DOWN:format(difficultyName.."-"..bossName, time))
			end
		end
	end
	
	local function fakeHandleSync(channel, sender, prefix, ...)
		if not prefix then
			return
		end
		-- This is where DBM checks if channel is WHISPER; we happen to know it's always CHANNEL
		local handler
		handler = fakeSyncHandlers[prefix]
		if handler then
			--print("Handler",...)
			return handler(sender, ...)
		end
	end	
	
	
	old_DBM_CHAT_MSG_ADDON=DBM.CHAT_MSG_ADDON	
	DBM.CHAT_MSG_ADDON=function(self,prefix, msg, channel, sender)
		old_DBM_CHAT_MSG_ADDON(self,prefix,msg,channel,sender)

		if(channel=="CHANNEL")then
			sender = Ambiguate(sender, "none")
			fakeHandleSync(channel, sender, strsplit("\t", msg))
		end
	end
	
	
else
	print("GW-Raiding couldn't start correctly because DBM hasn't loaded yet.")
end

-------------------------------------------------------------
----------------------------DEBUG----------------------------
-------------------------------------------------------------
--Pull
--/run SendAddonMessage("D4", "GCB\t"..tostring(1898).."\t2\t"..tostring(16), "GUILD")
--Success
--/run SendAddonMessage("D4", "GCE\t"..tostring(1898).."\t3\t0\t"..strFromTime(523.29).."\t"..tostring(16), "GUILD")
--Wipe
--/run SendAddonMessage("D4", "GCE\t"..tostring(1898).."\t3\t1\t"..strFromTime(523.29).."\t"..tostring(16).."\t".."1% (Stage 3)", "GUILD")
--/run SendAddonMessage("D4", "GCE\t"..tostring(1898).."\t3\t0\t"..strFromTime(523.29).."\t"..16, "WHISPER", "(YOUR NAME HERE)")
---- when using these, make sure greenwall is actually channel #1!
--/run SendAddonMessage("D4", "GCE\t"..tostring(1898).."\t3\t0\t"..strFromTime(523.29).."\t"..tostring(16).."\t"..tostring(0).."\tomen", "CHANNEL",1)
--/run SendAddonMessage("D4", "GCE\t"..tostring(1898).."\t3\t0\t"..strFromTime(523.29).."\t"..tostring(16).."\t"..tostring(0).."\tmoonfang", "CHANNEL",1)

--/run SendAddonMessage("D4", "GCE\t"..tostring(1898).."\t3\t1\t"..strFromTime(523.29).."\t"..tostring(16).."\t".."1% (Stage 3)".."\tmoonfang", "CHANNEL",1)
--/run SendAddonMessage("D4", "GCE\t"..tostring(1897).."\t3\t0\t"..strFromTime(290.52).."\t"..tostring(15).."\t"..tostring(0).."\tazuregos", "CHANNEL",1)
--/run SendAddonMessage("D4", "GCB\t"..tostring(1898).."\t2\t"..tostring(16).."\tmoonfang", "CHANNEL",1)
--/run SendAddonMessage("D4", "GCE\t"..tostring(1725).."\t3\t0\t"..strFromTime(200.22).."\t"..tostring(15).."\t"..tostring(0).."\tnalak", "CHANNEL",1)
--/run SendAddonMessage("D4", "GCE\t"..tostring(2031).."\t3\t1\t"..strFromTime(10.77).."\t"..tostring(15).."\t".."98% (Stage 1)".."\tordos", "CHANNEL",1)
--/run SendAddonMessage("D4", "GCB\t"..tostring(1725).."\t2\t"..tostring(15).."\tkazzak", "CHANNEL",1)
--/run SendAddonMessage("D4", "GCE\t"..tostring(1667).."\t3\t0\t"..strFromTime(45.40).."\t"..tostring(15).."\t"..tostring(0).."\tgalleon", "CHANNEL",1)

-- -- not local so we can /run it from the chat box
-- function strFromTime(time)
	-- if type(time) ~= "number" then time = 0 end
	-- time = floor(time*100)/100
	-- if time < 60 then
		-- return DBM_CORE_TIMER_FORMAT_SECS:format(time)
	-- elseif time % 60 == 0 then
		-- return DBM_CORE_TIMER_FORMAT_MINS:format(time/60)
	-- else
		-- return DBM_CORE_TIMER_FORMAT:format(time/60, time % 60)
	-- end
-- end
-------------------------------------------------------------